local function run_wrapped_function(f_env)

dofile("scripts/base/util.lua")

-- print("chat:", f_env.path, f_env.query, f_env.text)

text = f_env.text

f = io.open("chat-dump.html", "a+")
f:write(tostring(text).."\n")
f:close()

local chatprinters = {}
local json_chatprinters = {}

function load_file(category, name)
	function add_json_chat_printer(func)
		table.insert(json_chatprinters, { scriptname = name, f = func })
	end
	function add_chat_printer(func)
		table.insert(chatprinters, { scriptname = name, f = func })
	end
	function add_chat_trigger() end
	function add_interceptor() end
	if category == "chat" then
		dofile("scripts/"..name)
	end
end

local orig_text = text
dofile("scripts/loaders.lua")
dofile("scripts/user-loaders.lua")
text = orig_text

if text:contains([["last":]]) then
	local chat_tbl = json_to_table(text)
	for i, msg in ipairs(chat_tbl.msgs) do
		for _, printer in ipairs(json_chatprinters) do
			printer.f(msg)
		end
-- 		print("msg"..i..": ", msg)
	end
	text = table_to_json(chat_tbl)
elseif text:contains("lastseen:") then
	-- print("  . . .  ")
	-- print(text)
	-- print(" -1- ")
	text = "<!-- buffer br --><br>" .. text
	text = text:gsub("<!%-%-lastseen:[0-9]+%-%->$", "<!-- separator:beforeA -->%0") -- lastseen at the end
	text = text:gsub([[<font color=[^>]+>%b[]</font> <b><a target=mainpane href="showplayer%.php%?who=[0-9]+"><font color=[^>]+>[^<]+</font></b></a>]], "<!-- separator:beforeB --><!-- separator:startB -->%0") -- normal chat
	text = text:gsub([[<font color=[^>]+>%b[]</font> <b><i><a target=mainpane href="showplayer%.php%?who=[0-9]+"><font color=[^>]+>[^<]+</b></font></a>]], "<!-- separator:beforeC --><!-- separator:startC -->%0") -- emote in chat
	text = text:gsub([[<br>(<b><a target=mainpane href="showplayer%.php%?who=[0-9]+"><font color=[^>]+>[^<]+</font></b></a>)]], "<br><!-- separator:beforeD --><!-- separator:startD -->%1") -- normal chat
	text = text:gsub([[<br>(<b><i><a target=mainpane href="showplayer%.php%?who=[0-9]+"><font color=[^>]+>[^<]+</b></font></a>)]], "<br><!-- separator:beforeE --><!-- separator:startE -->%1") -- emote in chat
	text = text:gsub([[<a target=mainpane href="showplayer%.php%?who=[0-9]+"><font color=[^>]+><b>[^<]+</b></a>]], "<!-- separator:beforeF --><!-- separator:startF -->%0") -- private message
	-- print(text)
	-- print(" -2- ")
	text = text:gsub("<!%-%- separator:start[A-Z] %-%->(.-)<!%-%- separator:before[A-Z] %-%->", function (msg)
	--  	print("chatmsg", msg)
		for _, printer in ipairs(chatprinters) do
			msg = printer.f(msg)
	--  		print("stepmsg", msg, printer.scriptname)
		end
	--  	print("becamsg", msg)
		return msg
	end)
	-- print(" -3- ")
	text = text:gsub("<!%-%- separator:[a-zA-Z]+ %-%->", "")
	text = text:gsub("^<!%-%- buffer br %-%-><br>", "")
	-- print(text)
	-- print("  . . .  ")

	-- text = orig_text
end



return text

end

return run_wrapped_function
